# How to Add Custom Repositories to Androidacy Module Manager

## Table of Contents

- [Introduction](#introduction)
- [Adding a Repo for Personal Use](#adding-a-repo-for-personal-use)
- [Adding a Repo for Public Use](#adding-a-repo-for-public-use)
- [How to Apply for Inclusion](#how-to-apply)

## Introduction

This guide shows you how to add custom repositories to the Androidacy Module Manager (AMM). There are two ways to do this:

1. **Adding a Repo for Personal Use**: This is for individual users who want to add a specific repo just for themselves.
2. **Adding a Repo for Public Use**: This is for repo owners who want their repo to be available to all AMM users.

## Adding a Repo for Personal Use

### Steps

1. **Get the URL**: You need the `modules.json` link of the repo you want to add. If you don't have it, ask the repo owner.
2. **Open the App**: Go to the settings in the AMM app.
3. **Find Repos**: Click on the 'Repos' option at the top of the settings.
4. **Add New Repo**: Scroll down and click the 'Add repo' button.
5. **Enter the URL**: Paste the `modules.json` link and click 'Add'.

> **Note**: Some features might not work fully with custom repos.

## Adding a Repo for Public Use

### Requirements

**In short:**

- **Known Owner**: The repo or one of its owners should be well-known.
- **Safe Modules**: The repo should actively remove any harmful modules.
- **Updated Data**: The repo must have an up-to-date `modules.json` file.

**In detail:**
<details>
<summary>Click to expand full guidelines</summary>

- **Author Approval**: Repos should only host modules if the original author agrees or the license permits. If repository uses automated tools to add modules, they should have an opt out process or a way to request removal.
- **Privacy**: Don't collect personal data without telling users. Data used for advertising and analytics should be anonymized where possible, or otherwise declared in accordance with applicable laws.
- **Transparency**: Let module owners know if their module is on your repo and if you make any changes to it. This can be done by including a searchable list of modules on your website.
- **Safety**: Try to keep users safe by reviewing modules or using a whitelist/blacklist. Reasonable measures should be taken to prevent malware and other harmful modules from being hosted, and to protect other's intellectual property.

</details>

_**Note**: Repo owners can have their own rules, but they should not conflict with these guidelines. Always check the repo's own guidelines. In addition, these are just guidelines, and Androidacy reserves the right to remove any repo or refuse to add any repo for any reason whatsoever._

### How to Apply

If your repo meets these requirements, open an issue with:

- **Repo Name**: The name of your repo.
- **Website**: The official website of the repo.
- **Contact**: A way to contact you, like email or Telegram.
- **How to Add**: Steps or documentation on how to add the repo to AMM.

**Note**: Each repo will be reviewed on a case-by-case basis. Meeting these guidelines does not guarantee inclusion in AMM.

> Copyright © 2023 Androidacy. All Rights Reserved.
